
# client initialization
dsmclntinit <- function(host="localhost",port) {
   con <- socketConnection(host=host,port=port, blocking=T)
   writeLines("checking in",con)
   myidandnclnt <- unserialize(con)
   dsmclntglbls <<- list()  # globals
   dsmclntinfo <- list(mycon=con,myid=myidandnclnt[1],nclnt=myidandnclnt[2])
}

# shared constructor, creating object with quoted name varname value
# val, of type datatype, sending to server via con
dsmclntnew <- function(varname,val,datatype) {
   # build the object
   rtrn <- list()
   class(rtrn) <- "dsm"
   rtrn$val <- data  # variable value
   # add to local globals
   dsmclntglbls[[varname]] <<- rtrn
   rtrn$varname <- varname
   rtrn$reqtype <- "new"
   # send to server
   serialize(rtrn,dsmclntinfo$mycon)
   return(rtrn)
}

# subscript get operation on dsm object, a vector v
"[.dsm" <- function(v,subs) {
   tosrvr <- list()
   tosrvr$varname <- v$varname
   tosrvr$req <- "vector get"
   tosrvr$subs <- subs
   serialize(tosrvr,dsmclntinfo$mycon)
   return(v$vec[subs])
}

# subscript put operation on dsmv object v 
# R requires that last arg for [<- generics be named "value"
"[<-.dsmv" <- function(v,subs,value) {
   v$vec[subs] <- value
   return(v)
}

